#!/bin/bash
# Basé sur un travail de Cédric Abonnel / Cédrix sous licence CC BY-NC 4.0

# Importer les fonctions communes
source "$(dirname "$0")/../common/common_utils.sh"

# Vérifier si le script est exécuté en root
check_root

# Fichier de configuration de dnsmasq
DNSMASQ_CONF="/etc/dnsmasq.d/custom_hosts"

# Vérifier que dnsmasq est installé
if ! command -v dnsmasq &> /dev/null; then
    echo "dnsmasq n'est pas installé. Installez-le avec : sudo ./setup_dhcp.sh"
    exit 1
fi

# Vérifier les arguments
if [[ $# -lt 2 ]]; then
    echo "Usage: $0 <IP> <HOSTNAME1> [HOSTNAME2] [HOSTNAME3] ..."
    exit 1
fi

IP="$1"
shift  # Supprime le premier argument pour ne garder que les hostnames
HOSTNAMES=("$@")

# Fonction pour obtenir le PTR record formaté
get_ptr_record() {
    local ip="$1"
    local reversed_ip=$(echo "$ip" | awk -F. '{print $4"."$3"."$2"."$1".in-addr.arpa"}')
    echo "$reversed_ip"
}

# Fonction pour vérifier si un PTR existe
is_ptr_registered() {
    local ip="$1"
    local ptr=$(get_ptr_record "$ip")
    grep -q "ptr-record=$ptr" "$DNSMASQ_CONF"
    return $?
}

# Fonction pour obtenir le FQDN d'un hostname
get_fqdn() {
    local hostname="$1"
    local domain_name=$(dnsdomainname)
    if [[ -n "$domain_name" ]]; then
        echo "$hostname.$domain_name"
    else
        echo "$hostname"
    fi
}


# Fonction pour obtenir le FQDN réel avec `host`
get_actual_fqdn() {
    local ip="$1"
    local actual_fqdn=$(host "$ip" | awk '/domain name pointer/ {print $5}' | sed 's/\.$//')
    echo "$actual_fqdn"
}

# Fonction pour vérifier si un hostname est déjà enregistré
is_hostname_registered() {
    local hostname="$1"
    grep -q "address=/$hostname/$IP" "$DNSMASQ_CONF"
    return $?
}

# Variable pour suivre si un changement a été fait
MODIFIED=0
MODIFIED_BY_HOSTNAME=0
MODIFIED_BY_FQDN=0

# Vérifier si l'IP existe déjà dans le fichier
EXISTING_HOSTNAMES=($(grep -E "address=/[^ ]+/$IP$" "$DNSMASQ_CONF" | sed -E "s/address=\/([^\/]+)\/$IP/\1/"))

if [[ ${#EXISTING_HOSTNAMES[@]} -gt 0 ]]; then
    echo "L'adresse IP $IP existe déjà avec les noms suivants : ${EXISTING_HOSTNAMES[*]}"
else
    echo "Nouvelle adresse IP détectée : $IP"
fi

# Vérifier et ajouter chaque hostname
for HOSTNAME in "${HOSTNAMES[@]}"; do
    FQDN=$(get_fqdn "$HOSTNAME")
    echo "Le FQDN détecté pour $HOSTNAME est : $FQDN"
    
    if is_hostname_registered "$FQDN"; then
        echo "L'association $FQDN -> $IP existe déjà."
    else
        read -p "Le FQDN $FQDN n'est pas dans la liste. Voulez-vous l'ajouter ? (o/N) " REPLY
        # Si aucune entrée n'est faite dans le délai imparti, on met "n" par défaut
        if [[ -z "$REPLY" ]]; then
            REPLY="n"
            echo -e "\nRéponse par défaut : n"
        fi
        if [[ "$REPLY" =~ ^[Oo]$ ]]; then
            echo "address=/$FQDN/$IP" >> "$DNSMASQ_CONF"
            echo "Ajout de : $FQDN -> $IP"
            MODIFIED=1
            MODIFIED_BY_FQDN=1
        fi
    fi

    if is_hostname_registered "$HOSTNAME"; then
        echo "L'association $HOSTNAME -> $IP existe déjà."
    else
        echo "address=/$HOSTNAME/$IP" >> "$DNSMASQ_CONF"
        echo "Ajout de : $HOSTNAME -> $IP"
        MODIFIED=1
        MODIFIED_BY_HOSTNAME=1
    fi

    # Vérification et ajout du PTR record
    PTR_RECORD=$(get_ptr_record "$IP")
    EXISTING_PTR=$(grep -E "ptr-record=$PTR_RECORD," "$DNSMASQ_CONF" | cut -d'=' -f2)

    if [[ $MODIFIED -eq 1 ]]; then
        # Déterminer $ACTUAL_FQDN
        test $MODIFIED_BY_HOSTNAME -eq 1 && ACTUAL_FQDN=$HOSTNAME
        if is_hostname_registered "$FQDN"; then
            ACTUAL_FQDN=$FQDN
        fi
        test $MODIFIED_BY_FQDN -eq 1 && ACTUAL_FQDN=$FQDN
    else
        ACTUAL_FQDN=""

        if is_hostname_registered "$HOSTNAME"; then
            ACTUAL_FQDN=$HOSTNAME
        fi
        if is_hostname_registered "$FQDN"; then
            ACTUAL_FQDN=$FQDN
        fi
    fi

    # Si ACTUAL_FQDN n'est pas vide, alors
    if [[ -n "$ACTUAL_FQDN" ]]; then
        # Si l'enregistrement actuel ne correspond pas déjà à $ACTUAL_FQDN, procéder à la mise à jour
        if [[ "$(get_actual_fqdn "$IP")" != "$ACTUAL_FQDN" ]]; then
            if [[ -n "$EXISTING_PTR" ]]; then
                if [[ "$EXISTING_PTR" != "ptr-record=$PTR_RECORD,$ACTUAL_FQDN" ]]; then
                    read -p "Voulez-vous le remplacer ? (o/N) " REPLY
                    if [[ -z "$REPLY" ]]; then
                        REPLY="n"
                        echo -e "\nRéponse par défaut : n"
                    fi
                    if [[ "$REPLY" =~ ^[Oo]$ ]]; then
                        sed -i "/ptr-record=$PTR_RECORD/d" "$DNSMASQ_CONF"
                        echo "ptr-record=$PTR_RECORD,${ACTUAL_FQDN}" >> "$DNSMASQ_CONF"
                        echo "PTR mis à jour : $PTR_RECORD -> ${ACTUAL_FQDN}"
                        MODIFIED=1
                    fi
                fi
            else
                echo "ptr-record=$PTR_RECORD,${ACTUAL_FQDN}" >> "$DNSMASQ_CONF"
                echo "Ajout du PTR : $PTR_RECORD -> ${ACTUAL_FQDN}"
                MODIFIED=1
            fi
        fi
    fi

done



# Redémarrer dnsmasq seulement si des changements ont été faits
if [[ $MODIFIED -eq 1 ]]; then
    systemctl restart dnsmasq
    echo "Redémarrage de dnsmasq effectué."
else
    echo "Aucune modification nécessaire."
fi